module interfaceA(
    input logic fast_clk,
    input logic [1:0] command,
    input logic [7:0] data_in,
    input logic [11:0] rd_data,
    output logic [7:0] addr,
    output logic wr,
    output logic [11:0] wr_data,
    output logic rd,
    output logic [7:0] data_out
    );
    
    always_comb begin
        data_out <= rd_data;
    end
    
    always@(posedge fast_clk) begin
        if (command == 2'b00) begin     //write at availible address
            
        end
        else if (command == 2'b01) begin //write at this address
            addr <= data_in;
            wr_data <= 12'h000;
            wr <= 1'b0;
            rd <= 1'b0;
        end
        else if (command == 2'b10) begin //write this 
            wr_data <= data_in;
            addr <= addr;
            wr <= 1'b1;
            rd <= 1'b0;
        end
        else if (command == 2'b11) begin //read
            rd <= 1'b1;
            wr <= 1'b0;
            wr_data <= 12'h000;
            addr <= addr;        
        end
        else begin //error
            rd <= 1'b0;
            wr <= 1'b0;
            addr <= 8'h00;
            wr_data <= 12'h000;
        end
    end
    
endmodule
