module memory(
    input logic fast_clk,
    input logic wr,
    input logic rd,
    input logic [11:0] wr_data,
    input logic [7:0] addr,
    input logic [7:0] wr_addr,
    output logic [11:0] rd_data,
    output logic [11:0] data
    );
    
    integer i;
     reg [11:0] memory_change_pos [254:0];
    
    initial begin
        i <= 0;
        //saved
        memory_change_pos[0] <= 12'h100;
        memory_change_pos[1] <= 12'h100;
        //setup
        memory_change_pos[2] <= 12'h316;
        memory_change_pos[3] <= 12'h256;
        memory_change_pos[4] <= 12'h287;
        memory_change_pos[5] <= 12'h2C7;
        memory_change_pos[6] <= 12'h202;
        memory_change_pos[7] <= 12'h880; //end comand for waveform, resets counter
        
        memory_change_pos[9] <= 12'h403;   //loop start, repeat= 3  
        //sample
        memory_change_pos[10] <= 12'h225;
        memory_change_pos[10] <= 12'h2D5;
        memory_change_pos[10] <= 12'h2E3;
        memory_change_pos[10] <= 12'h271;
        memory_change_pos[10] <= 12'h2A1;
        memory_change_pos[10] <= 12'h2B3;
        memory_change_pos[10] <= 12'h100; //do nothing 16 clock periods
        memory_change_pos[10] <= 12'h2D3;
        memory_change_pos[10] <= 12'h2F4;
        memory_change_pos[10] <= 12'h260;
        memory_change_pos[10] <= 12'h290;
        memory_change_pos[10] <= 12'h3A4;
        memory_change_pos[10] <= 12'h2A3;
        memory_change_pos[10] <= 12'h2C2;
        memory_change_pos[10] <= 12'h2F6;
        memory_change_pos[10] <= 12'h236;
        memory_change_pos[10] <= 12'h870; //end command for waveform, resets counter
        
        memory_change_pos[10] <= 12'hB02; //resets waveform for looping
        memory_change_pos[10] <= 12'h50A; //loop end
        memory_change_pos[10] <= 12'hB02; // cancel reset of waveform for looping
        //shutter 
        memory_change_pos[10] <= 12'h237;
        memory_change_pos[10] <= 12'h277;
        memory_change_pos[10] <= 12'h2B5;
        memory_change_pos[10] <= 12'h2D4;
        memory_change_pos[10] <= 12'h244;
        memory_change_pos[10] <= 12'h265;
        memory_change_pos[10] <= 12'h100; //do nothing 16 clock cycles
        memory_change_pos[10] <= 12'h840; //end command for waveform, resets counter
        
    end
    
    always @ (posedge fast_clk) begin
        data <= memory_change_pos[addr];
        
        if(wr)
            memory_change_pos[wr_addr] <= wr_data;
        if(rd) begin
            rd_data <= memory_change_pos[i];
            if(i==254)
                i = 0;
            else
                i = i + 1;
        end 
    end
endmodule
