module data_handle(
    input logic rst,
    input logic[15:0] data,
    input logic fast_clk,
    output logic[3:0] wave_pos,
    output logic [11:0] wave,
    output logic nxt_index,
    output logic[7:0] loop_addr,
    output logic[7:0] loop_repeat,
    output logic increase,
    output logic jump_fetch,
    output logic[7:0] D_jump
    );
    
    always_comb begin
        if(rst) begin
            wave = 12'h000;
            nxt_index = 1'b0;
            loop_addr = 8'h00;
            loop_repeat = 8'h00;
            increase = 1'b0;
            jump_fetch = 1'b0;
            D_jump = 8'h00;
        end else begin
            if(data[15:12]==4'h2) begin
                wave = data[11:0];
                loop_addr = loop_addr;
                loop_repeat = loop_repeat;
                increase = 1'b0;
                jump_fetch = 1'b0;
                D_jump = D_jump;
            end 
            else if(data[15:12]==4'h4) begin
                loop_repeat = data[7:0];
                wave = wave;
                loop_addr = loop_addr;
                increase = 1'b0;
                jump_fetch = 1'b0;
                D_jump = D_jump;
            end 
            else if(data[15:12]==4'h5) begin
                loop_addr = data[7:0];
                wave = wave;
                loop_repeat = loop_repeat;
                increase = 1'b1;
                jump_fetch = 1'b0;
                D_jump = D_jump;
            end 
            else if(data[15:12]==4'h6) begin
                wave = wave;
                loop_addr = loop_addr;
                loop_repeat = loop_repeat;
                increase = 1'b0;
                jump_fetch = 1'b1;
                D_jump = data[7:0];
            end 
            else if(data[15:12]==4'h7) begin
                wave = data[7:0];
                loop_addr = 8'h00;
                loop_repeat = 1'b0;
                increase = 1'b0;
                jump_fetch = 1'b0;
                D_jump = data[7:0];
            end 
         end
    end
endmodule
