module memory(
    input logic fast_clk,
    input logic wr,
    input logic rd,
    input logic [11:0] wr_data,
    input logic [7:0] addr,
    input logic [7:0] wr_addr,
    output logic [11:0] rd_data,
    output logic [15:0] data,
    output logic [15:0] sig1,
    output logic [15:0] sig2,
    output logic [15:0] sig3,
    output logic [15:0] sig4,
    output logic [15:0] sig5,
    output logic [15:0] sig6,
    output logic [15:0] sig7
    );
    
    integer i;
     reg [15:0] memory_toggle [23:0];
    
    initial begin
        i <= 0;
        //saved
        memory_toggle[0] <= 16'h2000;
        memory_toggle[1] <= 16'h2000;
        //setup
        memory_toggle[2] <= 16'h209D;
        memory_toggle[3] <= 16'h2026;
        memory_toggle[4] <= 16'h2000;
        memory_toggle[5] <= 16'h2000;
        memory_toggle[6] <= 16'h2000;
        memory_toggle[7] <= 16'h2002;
        memory_toggle[8] <= 16'h2000;
        memory_toggle[9] <= 16'h2000;
       
        
        //sample
        
    end
    
    always @ (posedge fast_clk) begin
        data <= memory_toggle[addr];
        sig1 <= memory_toggle[addr+1];
        sig2 <= memory_toggle[addr+2];
        sig3 <= memory_toggle[addr+3];
        sig4 <= memory_toggle[addr+4];
        sig5 <= memory_toggle[addr+5];
        sig6 <= memory_toggle[addr+6];
        sig7 <= memory_toggle[addr+7];
        
        /*if(wr)
            memory_all_bit[wr_addr] <= wr_data;
        if(rd) begin
            rd_data <= memory_all_bit[i];
            if(i==254)
                i = 0;
            else
                i = i + 1;
        end */
    end
endmodule

module memory_handler (
    input logic [11:0] data,
    input logic nxt_index,
    input logic fast_clk,
    input logic rst,
    output logic [3:0] pos,
    output logic done);
    
    integer start_index;
    integer end_index;
    
    
    always@(posedge fast_clk) begin
        if(rst) begin
            pos <= 4'h0;
            start_index <= 11;
            end_index <= 8;
            done <= 1'b0;
        end else if(nxt_index) begin
            pos <= data[11:8];
            if(end_index == 0) begin
                start_index <= 11;
                end_index <= 8;
                done <= 1'b1;
            end else begin
                start_index <= end_index-1;
                end_index <= end_index-4;
                done <= 1'b0;
            end
        end else begin
            pos <= pos;
            start_index <= start_index;
            end_index <= end_index;
            done <= done;
        end
    end
endmodule
