module memory(
    input logic fast_clk,
    input logic wr,
    input logic rd,
    input logic [11:0] wr_data,
    input logic [7:0] addr,
    input logic [7:0] wr_addr,
    output logic [11:0] rd_data,
    output logic [11:0] data,
    output logic [7:0] wave_data
    );
    
    integer i;
     reg [11:0] InstMemory [254:0];
     logic[3:0] wave_addr;
     
     memory_wave memory_wave1(.fast_clk(fast_clk), .addr(wave_addr), .wave_data(wave_data));
    
    initial begin
        
        InstMemory[0] <= 12'h210;
        InstMemory[1] <= 12'h403;       //Loop start
        //setup
        InstMemory[2] <= 12'h210;       //normal
        InstMemory[3] <= 12'h242;       //normal
        InstMemory[4] <= 12'h230;       //normal
        InstMemory[5] <= 12'h241;       //normal
        InstMemory[6] <= 12'h240;       //normal
        InstMemory[7] <= 12'h293;       //normal
        
        InstMemory[8] <= 12'h403;       //Loop start
        //sample
        InstMemory[9] <= 12'h223;       
        InstMemory[9] <= 12'h2B4;    
        InstMemory[9] <= 12'h213;
        InstMemory[9] <= 12'h295;
        InstMemory[9] <= 12'h236;
        InstMemory[9] <= 12'h215;
        InstMemory[9] <= 12'h2F3;
        InstMemory[9] <= 12'h2F3;   
        InstMemory[9] <= 12'h225;
        InstMemory[9] <= 12'h277;
        InstMemory[9] <= 12'h238;
        InstMemory[9] <= 12'h217;
        InstMemory[9] <= 12'h223;
        InstMemory[9] <= 12'h230;
        InstMemory[9] <= 12'h242;
        InstMemory[9] <= 12'h250;
        
        InstMemory[9] <= 12'h509;  //loop end
        //shutter 
        InstMemory[9] <= 12'h230;
        InstMemory[9] <= 12'h241;
        InstMemory[9] <= 12'h240;
        InstMemory[9] <= 12'h229;
        InstMemory[9] <= 12'h27A;
        InstMemory[9] <= 12'h229;
        InstMemory[9] <= 12'h2F0;
        InstMemory[9] <= 12'h260;
        

        
    end
    
    always @ (posedge fast_clk) begin
        data <= InstMemory[addr];
        wave_addr <= InstMemory[addr][3:0];
        
        if(wr)
            memory_all_bit[wr_addr] <= wr_data;
        if(rd) begin
            rd_data <= memory_all_bit[i];
            if(i==254)
                i = 0;
            else
                i = i + 1;
        end 
    end
endmodule


module memory_wave (
    input logic fast_clk,
    input logic[3:0] addr,
    output logic[7:0] wave_data);
    
    reg [7:0] WaveMemory [10:0];
    
    initial begin
        WaveMemory[0] <= 8'h00;
        WaveMemory[1] <= 8'h80;
        WaveMemory[2] <= 8'h40;
        WaveMemory[3] <= 8'h04;
        WaveMemory[4] <= 8'h24;
        WaveMemory[5] <= 8'h0C;
        WaveMemory[6] <= 8'h0E;
        WaveMemory[7] <= 8'h1C;
        WaveMemory[8] <= 8'h1D;
        WaveMemory[9] <= 8'h20;
        WaveMemory[10] <= 8'h30;
        
    end
    
    always @ (posedge fast_clk) begin

        wave_data <= WaveMemory[addr];
    end
    
endmodule
