/*
module memory(
    input logic fast_clk,
    input logic wr,
    input logic rd,
    input logic[7:0] addr,
    input logic[15:0] wdata,
    output logic[11:0] rdata,
    output logic[7:0] wave_data);
    
    reg [11:0] InstMemory [254:0];
    logic [3:0] lsb;

    memoryw waveinfo (.fast_clk(fast_clk), .addr(lsb), .wave_data(wave_data));
    
    initial begin
        
        InstMemory[0] <= 12'h211;
        InstMemory[1] <= 12'h222;       //Loop start
        InstMemory[2] <= 12'h210;       //normal
        InstMemory[3] <= 12'h242;       //normal
        InstMemory[4] <= 12'h230;       //normal
        InstMemory[5] <= 12'h218;       //Jump, no break
        InstMemory[6] <= 12'h241;       //normal
        InstMemory[7] <= 12'h240;       //normal
        InstMemory[8] <= 12'h293;       //normal
        InstMemory[9] <= 12'h502;       //Loop stop
        InstMemory[10] <= 12'h2AA;       //normal
        InstMemory[11] <= 12'h706;      //Jump, break loop
        InstMemory[12] <= 12'h236;      //normal
        InstMemory[13] <= 12'h606;      //Jump, no break 
        
    end
    
    always @ (posedge fast_clk) begin
        /*
        if(wr)
           InstMemory[addr] <= wdata;
        else 
           InstMemory[addr] <= InstMemory[addr];
        
        //wave_data <= WaveMemory[InstMemory[addr][3:0]];
        rdata <= InstMemory[addr];
        lsb <= InstMemory[addr][3:0];
    end
    
endmodule

module memoryw (
    input logic fast_clk,
    input logic[3:0] addr,
    output logic[7:0] wave_data);
    
    reg [7:0] WaveMemory [10:0];
    
    initial begin
        WaveMemory[0] <= 8'h00;
        WaveMemory[1] <= 8'h80;
        WaveMemory[2] <= 8'h40;
        WaveMemory[3] <= 8'h04;
        WaveMemory[4] <= 8'h24;
        WaveMemory[5] <= 8'h0C;
        WaveMemory[6] <= 8'h0E;
        WaveMemory[7] <= 8'h1C;
        WaveMemory[8] <= 8'h1D;
        WaveMemory[9] <= 8'h20;
        WaveMemory[10] <= 8'h30;
        
    end
    
    always @ (posedge fast_clk) begin

        wave_data <= WaveMemory[addr];
    end
    
endmodule
*/

module memory2(
    input logic fast_clk,
    input logic wr,
    input logic rd,
    input logic[7:0] addr,
    input logic[15:0] wdata,
    output logic[11:0] rdata,
    output logic[7:0] wave_data);
    
    reg [15:0] InstMemory [254:0];
    
    initial begin
        
        InstMemory[0] <= 16'h2280;
        InstMemory[1] <= 16'h2240;       //Loop start
        InstMemory[2] <= 16'h2100;       //normal
        InstMemory[3] <= 16'h2440;       //normal
        InstMemory[4] <= 16'h2300;       //normal
        InstMemory[5] <= 16'h211D;       //Jump, no break
        InstMemory[6] <= 16'h2480;       //normal
        InstMemory[7] <= 16'h2400;       //normal
        InstMemory[8] <= 16'h2904;       //normal
        InstMemory[9] <= 16'h5040;       //Loop stop
        InstMemory[10] <= 16'h2A30;       //normal
        //InstMemory[11] <= 12'h706;      //Jump, break loop
        //InstMemory[12] <= 12'h236;      //normal
        //InstMemory[13] <= 12'h606;      //Jump, no break 
        
    end
    
    always @ (posedge fast_clk) begin
        rdata <= InstMemory[addr][15:4];
        wave_data <= InstMemory[addr][7:0];
    end
    
endmodule